#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
main(argc, argv)
int argc;
char **argv;
{
   Display *d;       Window w;
   XIconSize *is;    int n, i, j;
   XWMHints wmh;     Pixmap bm;
   int xh, yh;       unsigned int width, height;
   Bool width_match = False, height_match = False;

   d = XOpenDisplay (NULL);
   w = XCreateSimpleWindow (d, RootWindow (d, 0), 200, 300,
                            100, 100, 2, 0, 1);
   XGetIconSizes (d, RootWindow (d, 0), &is, &n);
   XReadBitmapFile (d, w, argv[1], &width, &height, &bm, &xh, &yh);

   for (i = 0; i < n; i++)
     {for (j=is[i].min_width;j<=is[i].max_width;j+=is[i].width_inc)
        if (width == j) { width_match = True; break; }
      for (j=is[i].min_height;j<=is[i].max_height;j+=is[i].height_inc)
        if (height == j) { height_match = True; break; }
     }
   if ( width_match && height_match )
     { wmh.flags = IconPixmapHint;
       wmh.icon_pixmap = bm;
       XSetWMHints (d, w, &wmh);
     }

   XMapWindow (d, w);
   XFlush (d);
   getchar ();
}
